package com.chelvc.framework.database.config;

import lombok.Data;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.context.annotation.Configuration;

/**
 * 数据库配置属性
 *
 * @author Woody
 * @date 2024/1/30
 */
@Data
@Configuration
@ConfigurationProperties("database")
public class DatabaseProperties {
    /**
     * 敏感字段配置
     */
    private final Sensitive sensitive = new Sensitive();

    /**
     * 敏感字段配置
     */
    @Data
    public static class Sensitive {
        /**
         * 加解密密钥
         */
        private String secret;

        /**
         * 加解密初始向量
         */
        private String iv;

        /**
         * 字段是否同时包含明文和明文，如果包含则在使用该字段精确匹配时自动加入明文查询条件
         */
        private boolean mixed = false;

        /**
         * 是否可写入密文
         */
        private boolean writable = true;
    }
}
