package com.chelvc.framework.security.serializer;

import java.io.IOException;
import javax.crypto.Cipher;

import com.chelvc.framework.common.util.AESUtils;
import com.chelvc.framework.common.util.ObjectUtils;
import com.chelvc.framework.security.context.SecurityContextHolder;
import com.fasterxml.jackson.core.JsonGenerator;
import com.fasterxml.jackson.databind.JsonSerializer;
import com.fasterxml.jackson.databind.SerializerProvider;

/**
 * 敏感字符串数组序列化处理器
 *
 * @author Woody
 * @date 2024/6/21
 */
public class SensitiveArraySerializer extends JsonSerializer<String[]> {
    @Override
    public void serialize(String[] value, JsonGenerator generator, SerializerProvider provider)
            throws IOException {
        if (ObjectUtils.notEmpty(value)) {
            Cipher cipher = SecurityContextHolder.getEncryptor();
            value = SecurityContextHolder.mark(AESUtils.encrypt(cipher, value));
        }
        generator.writeObject(value);
    }
}
