package com.chelvc.framework.wechat;

import java.util.Map;

/**
 * 微信支付操作接口
 *
 * @author Woody
 * @date 2024/6/19
 */
public interface WechatPaymentHandler {
    /**
     * 参数签名
     *
     * @param type       应用分类
     * @param parameters 签名参数
     * @return 签名信息
     */
    String sign(String type, Map<String, String> parameters);

    /**
     * 校验参数有效性
     *
     * @param type       应用分类
     * @param parameters 参数键/值对
     * @return true/false
     */
    boolean validate(String type, Map<String, String> parameters);

    /**
     * 微信统一下单
     *
     * @param type    应用分类
     * @param request 支付请求参数
     * @return 微信统一下单信息
     */
    WechatUnifiedOrder unifiedorder(String type, WechatPayRequest request);
}
